# FoundationClasses
TKernel
TCollection

# TCollection_BasicMapIterator Class Reference

This class provides basic services for the
iterators on Maps. The iterators are inherited
from this one.
The iterator contains an array of pointers
(buckets). Each bucket is a pointer on a node. A
node contains a pointer on the next node.
This class provides also basic services for the
implementation of Maps.
A map iterator provides a step by step exploration of all
entries of a map. After initialization of a concrete derived
iterator, use in a loop:
- the function More to know if there is a current entry for
the iterator in the map,
- then the functions which read data on an entry of the
map (these functions are provided by each type of map),
- then the function Next to set the iterator to the next entry of the map.
Warning
- A map is a non-ordered data structure. The order in
which entries of a map are explored by the iterator
depends on its contents, and change when the map is edited.
- It is not recommended to modify the contents of a map
during iteration: the result is unpredictable.
.

`#include <TCollection_BasicMapIterator.hxx>`

Inheritance diagram for TCollection_BasicMapIterator:

[legend]

## Public Member Functions

void * | operator new (size_t, void *anAddress)
void * | operator new (size_t size)
void | operator delete (void *anAddress)
Standard_EXPORT void | Reset ()
| Resets the iterator to the first node. .
Standard_Boolean | More () const
| Returns true if there is a current entry for this iterator in the map. Use the function Next to set this iterator to the position of the next entry, if it exists. .
Standard_EXPORT void | Next ()
| Sets this iterator to the position of the next entry of the map. Nothing is changed if there is no more entry to explore in the map: this iterator is always positioned on the last entry of the map but the function More returns false. .

## Protected Member Functions

Standard_EXPORT | TCollection_BasicMapIterator ()
| Creates an empty iterator. .
Standard_EXPORT | TCollection_BasicMapIterator (const TCollection_BasicMap &M)
| Initialize on the first node in the buckets. .
Standard_EXPORT void | Initialize (const TCollection_BasicMap &M)
| Initialize on the first node in the buckets. .

## Protected Attributes

Standard_Address | myNode

## Private Attributes

Standard_Integer | myNbBuckets
Standard_Address | myBuckets
Standard_Integer | myBucket

## Constructor & Destructor Documentation

Standard_EXPORT TCollection_BasicMapIterator::TCollection_BasicMapIterator | ( |  | ) | `[protected]`

Standard_EXPORT TCollection_BasicMapIterator::TCollection_BasicMapIterator | ( | const TCollection_BasicMap & | M | ) | `[protected]`

## Member Function Documentation

Standard_EXPORT void TCollection_BasicMapIterator::Initialize | ( | const TCollection_BasicMap & | M | ) | `[protected]`

Standard_Boolean TCollection_BasicMapIterator::More | ( |  | ) | const`[inline]`

Standard_EXPORT void TCollection_BasicMapIterator::Next | ( |  | ) |

| Reimplemented in TColStd_MapIteratorOfPackedMapOfInteger.

void TCollection_BasicMapIterator::operator delete | ( | void * | anAddress | ) | `[inline]`

Reimplemented in GraphDS_DataMapIteratorOfEntityRoleMap, Plugin_DataMapIteratorOfMapOfFunctions, Resource_DataMapIteratorOfDataMapOfAsciiStringAsciiString, Resource_DataMapIteratorOfDataMapOfAsciiStringExtendedString, Storage_DataMapIteratorOfMapOfCallBack, Storage_DataMapIteratorOfMapOfPers, Storage_MapIteratorOfMapOfAsciiString, TColgp_DataMapIteratorOfDataMapOfIntegerCirc2d, TColStd_DataMapIteratorOfDataMapOfIntegerInteger, TColStd_DataMapIteratorOfDataMapOfIntegerListOfInteger, TColStd_DataMapIteratorOfDataMapOfIntegerReal, TColStd_MapIteratorOfMapOfInteger, TColStd_MapIteratorOfMapOfReal, TColStd_MapIteratorOfMapOfTransient, and TopLoc_MapIteratorOfMapOfLocation.

void* TCollection_BasicMapIterator::operator new | ( | size_t | size | ) | `[inline]`

Reimplemented in GraphDS_DataMapIteratorOfEntityRoleMap, Plugin_DataMapIteratorOfMapOfFunctions, Resource_DataMapIteratorOfDataMapOfAsciiStringAsciiString, Resource_DataMapIteratorOfDataMapOfAsciiStringExtendedString, Storage_DataMapIteratorOfMapOfCallBack, Storage_DataMapIteratorOfMapOfPers, Storage_MapIteratorOfMapOfAsciiString, TColgp_DataMapIteratorOfDataMapOfIntegerCirc2d, TColStd_DataMapIteratorOfDataMapOfIntegerInteger, TColStd_DataMapIteratorOfDataMapOfIntegerListOfInteger, TColStd_DataMapIteratorOfDataMapOfIntegerReal, TColStd_MapIteratorOfMapOfInteger, TColStd_MapIteratorOfMapOfReal, TColStd_MapIteratorOfMapOfTransient, and TopLoc_MapIteratorOfMapOfLocation.

void* TCollection_BasicMapIterator::operator new | ( | size_t | ,
|  | void * | anAddress
| ) | `[inline]`

Reimplemented in GraphDS_DataMapIteratorOfEntityRoleMap, Plugin_DataMapIteratorOfMapOfFunctions, Resource_DataMapIteratorOfDataMapOfAsciiStringAsciiString, Resource_DataMapIteratorOfDataMapOfAsciiStringExtendedString, Storage_DataMapIteratorOfMapOfCallBack, Storage_DataMapIteratorOfMapOfPers, Storage_MapIteratorOfMapOfAsciiString, TColgp_DataMapIteratorOfDataMapOfIntegerCirc2d, TColStd_DataMapIteratorOfDataMapOfIntegerInteger, TColStd_DataMapIteratorOfDataMapOfIntegerListOfInteger, TColStd_DataMapIteratorOfDataMapOfIntegerReal, TColStd_MapIteratorOfMapOfInteger, TColStd_MapIteratorOfMapOfReal, TColStd_MapIteratorOfMapOfTransient, and TopLoc_MapIteratorOfMapOfLocation.

Standard_EXPORT void TCollection_BasicMapIterator::Reset | ( |  | ) |

| Reimplemented in TColStd_MapIteratorOfPackedMapOfInteger.

## Field Documentation

Standard_Integer TCollection_BasicMapIterator::myBucket `[private]`

Standard_Address TCollection_BasicMapIterator::myBuckets `[private]`

Standard_Integer TCollection_BasicMapIterator::myNbBuckets `[private]`

Standard_Address TCollection_BasicMapIterator::myNode `[protected]`

The documentation for this class was generated from the following files:

- TCollection_BasicMapIterator.hxx
- TCollection_BasicMapIterator.lxx